<template>
  <div>
    <h2>Sign In:</h2>
    <div class="form-group sign_in_form">
      <p>
        <input
          id='user_email'
          type="text"
          placeholder="Email"
          class="form-control"
          v-model="email"
        />
      </p>
      <p>
        <input
          id='user_password'
          type="password"
          placeholder="Password"
          class="form-control"
          v-model="password"
        />
      </p>
      <button id='sign_in_btn' class="btn btn-primary" @click='signIn'>Sign In</button>

    </div>
    <p><router-link to="/sign_up">Sing Up</router-link></p>
  </div>
</template>


<script>
  export default {
    data () {
      return {
        email: '',
        password: '',
        message: '',
        logged: this.$store.state.logged
      }
    },
    mounted() {
      this.checkUser()
      this.$root.$on('signInUser', (userParams) => {
        this.signInUser(userParams)
      })
    },
    methods: {
      signIn () {
        this.$root.$emit('signInUser', {email: this.email, password: this.password })
      },
      signInUser (userParams) {
        const url = '/api/v1/sessions'
        this.$http.post(url, { email: userParams['email'], password: userParams['password'] }).then((response) => {
          this.$store.dispatch('signIn', response.body.user)
          this.$router.push('/')
          this.$root.$emit('setFlashMsg', {message: response.body.message, type: 'normal' })
          this.$root.$emit('signIn')
        }).catch((error) => {
          this.$root.$emit('setFlashMsg', {message: error.body.message, type: 'error' })
        })
      },
      checkUser() {
        this.email = this.$store.state.user.email
        if(this.$store.state.user.email) {
          this.$router.push('/')
        }
      }
    }
  }
</script>
